<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'DatabaseUpdateException' => '\\StructType\\DatabaseUpdateException',
            'InvalidCredentialsException' => '\\StructType\\InvalidCredentialsException',
            'InvalidDataException' => '\\StructType\\InvalidDataException',
            'NoSuchContextException' => '\\StructType\\NoSuchContextException',
            'NoSuchResourceException' => '\\StructType\\NoSuchResourceException',
            'RemoteException' => '\\StructType\\RemoteException',
            'StorageException' => '\\StructType\\StorageException',
            'change' => '\\StructType\\Change',
            'create' => '\\StructType\\Create',
            'createResponse' => '\\StructType\\CreateResponse',
            'delete' => '\\StructType\\Delete',
            'getData' => '\\StructType\\GetData',
            'getDataResponse' => '\\StructType\\GetDataResponse',
            'getMultipleData' => '\\StructType\\GetMultipleData',
            'getMultipleDataResponse' => '\\StructType\\GetMultipleDataResponse',
            'list' => '\\StructType\\_list',
            'listAll' => '\\StructType\\ListAll',
            'listAllResponse' => '\\StructType\\ListAllResponse',
            'listResponse' => '\\StructType\\ListResponse',
            'Exception' => '\\StructType\\Exception',
            'IOException' => '\\StructType\\IOException',
            'Context' => '\\StructType\\Context',
            'Database' => '\\StructType\\Database',
            'SOAPStringMapMap' => '\\StructType\\SOAPStringMapMap',
            'SOAPMapEntry' => '\\StructType\\SOAPMapEntry',
            'SOAPStringMap' => '\\StructType\\SOAPStringMap',
            'Entry' => '\\StructType\\Entry',
            'Resource' => '\\StructType\\Resource',
            'Credentials' => '\\StructType\\Credentials',
        );
    }
}
